/*!
 * @file hud.h
 * @brief Definition of the ingame HUD.
*/

#ifndef _HUD_H
#define _HUD_H

#include "glgui_widget.h"
#include <list>

// FORWARD DECLARATION
class TiXmlElement;


//! A class that renders a HUD.
class Hud : private GLGuiWidget
{

public:
  Hud();
  virtual ~Hud();

  void loadParams(const TiXmlElement* root);

  void setBackGround();
  void setEnergyWidget(GLGuiWidget* widget);
  void setShiledWidget(GLGuiWidget* widget);
  void setArmorWidget(GLGuiWidget* widget);

  void addWeaponWidget(GLGuiWidget* widget);
  void removeWeaponWidget(GLGuiWidget* widget);

  void setResolution(unsigned int resX, unsigned int resY);

private:
  unsigned int             resX;          //!< The X-Resolution needed for resizing the Hud.
  unsigned int             resY;          //!< The Y-Resolution needed for resizing the Hud.

  GLGuiWidget*             energyWidget;
  GLGuiWidget*             shieldWidget;
  GLGuiWidget*             armorWidget;

  std::list<GLGuiWidget*>  weaponsWidgets; //!< WeaponWidgets will be displayed one after another
};

#endif /* _HUD_H */
